diff --git a/src/wizard/step/Step3.js b/src/wizard/step/Step3.js
new file mode 100644
index 0000000..af126a1
--- /dev/null
+++ b/src/wizard/step/Step3.js
@@ -0,0 +1,149 @@
+import React, { useState } from "react"
+import { shallowEqual, useSelector } from "react-redux"
+import { Card, CardBody, CardTitle, Button, Col, Row } from "reactstrap"
+
+import FedoraManualTesting from "../FedoraManualTesting"
+import FedoraEasyKarma from "../FedoraEasyKarma"
+import * as R from "ramda"
+
+const Step3 = (props) => {
+  const {
+    onNext,
+    onPrev,
+    steps: { step },
+  } = props
+
+  const [selectedItem, setItem] = useState(step.STEP3)
+
+  const handleStep = (option) => {
+    setItem(option)
+  }
+  const { STEP2 } = step
+  const selectAction = (state) => state.wizard.all_actions
+
+  const actions = useSelector(selectAction, shallowEqual)
+  console.log(actions)
+  const grouped = R.groupBy((action) => action.provider, actions[STEP2])
+
+  const processData = (data, firstLevelGroupKey, secondLevelGroupKey) => {
+    const getProcessedData = R.pipe(
+      R.groupBy((a) => a.extra_data[firstLevelGroupKey]),
+      R.map((v) => R.groupBy((a) => a.extra_data[secondLevelGroupKey], v))
+    )
+    return getProcessedData(data)
+  }
+
+  const manualTestingData = processData(
+    grouped["fedora_manual_testing"] || [],
+    "testtype",
+    "section"
+  )
+
+  const getData = () => {
+    const getUniqueTags = R.pipe(
+      R.map((action) => action.tags),
+      R.flatten,
+      R.uniq
+    )
+    const tags = getUniqueTags(grouped["easyfix"])
+    return tags
+  }
+
+  const getLanguageIcon = (lang) => {
+    switch (lang) {
+      case "Python":
+        return <i class="fab fa-python"></i>
+      case "JavaScript":
+        return <i class="fab fa-js-square"></i>
+      case "HTML":
+        return <i class="fab fa-html5"></i>
+      case "PHP":
+        return <i class="fab fa-php"></i>
+      default:
+        return <i class="fas fa-terminal"></i>
+    }
+  }
+
+  return (
+    <Row>
+      {step.STEP2 === "fedora_manual_testing" && (
+        <Col sm="12">
+          <FedoraManualTesting data={manualTestingData} key="fmtl" />
+
+          <Button
+            onClick={() => {
+              onPrev("STEP2")
+            }}
+            className="actions btn float-left"
+            color="primary">
+            <i class="fas fa-chevron-circle-left"></i> Previous
+          </Button>
+        </Col>
+      )}
+
+      {step.STEP2 === "fedora_easy_karma" && (
+        <Col sm="12">
+          <Card>
+            <CardBody>
+              <FedoraEasyKarma data={grouped["fedora_easy_karma"]} key="karma" />
+            </CardBody>
+          </Card>
+          <Button
+            className="actions btn float-left"
+            color="primary"
+            onClick={() => {
+              onPrev("STEP2")
+            }}>
+            <i class="fas fa-chevron-circle-left"></i> Previous
+          </Button>
+        </Col>
+      )}
+      {step.STEP2 === "easyfix" && (
+        <>
+          <Col sm="12">
+            <h1 className="event text-center">
+              Click on any of the below card to see programming language of your choice and press
+              next
+            </h1>
+          </Col>
+          {getData().map((lang) => (
+            <Col sm="6">
+              <Card
+                className={
+                  "clickable text-center" + (selectedItem === lang ? " card-selected" : "")
+                }
+                onClick={() => {
+                  handleStep(lang)
+                }}>
+                <CardBody>
+                  <CardTitle tag="h1">
+                    {lang} {getLanguageIcon(lang)}{" "}
+                  </CardTitle>
+                </CardBody>
+              </Card>
+            </Col>
+          ))}
+          <Col md="12">
+            <Button
+              className="actions btn float-left"
+              color="primary"
+              onClick={() => {
+                onPrev("STEP2")
+              }}>
+              <i class="fas fa-chevron-circle-left"></i> Previous
+            </Button>
+            <Button
+              color="primary"
+              className="actions btn float-right"
+              disabled={selectedItem === null}
+              onClick={(e) => onNext("STEP3", selectedItem)}>
+              <i class="fas fa-chevron-circle-right"></i> Next
+            </Button>
+          </Col>
+        </>
+      )}
+    </Row>
+  )
+}
+
+export default Step3
diff --git a/src/wizard/step/Step4.js b/src/wizard/step/Step4.js
new file mode 100644
index 0000000..357f11e
--- /dev/null
+++ b/src/wizard/step/Step4.js
@@ -0,0 +1,55 @@
+import React from "react"
+import { Button, Row, Col } from "reactstrap"
+import { shallowEqual, useSelector } from "react-redux"
+import * as R from "ramda"
+import Easyfix from "../Easyfix"
+
+const Step4 = (props) => {
+  const {
+    onNext,
+    onPrev,
+    steps: { step },
+  } = props
+
+  const { STEP2, STEP3 } = step
+
+  const selectAction = (state) => state.wizard.all_actions
+
+  const actions = useSelector(selectAction, shallowEqual)
+  console.log(actions)
+  const grouped = R.groupBy((action) => action.provider, actions[STEP2])
+
+  const processData = (data, firstLevelGroupKey, secondLevelGroupKey) => {
+    const getProcessedData = R.pipe(
+      R.groupBy((a) => a.extra_data[firstLevelGroupKey]),
+      R.map((v) => R.groupBy((a) => a.extra_data[secondLevelGroupKey], v))
+    )
+    return getProcessedData(data)
+  }
+
+  const getData = () => {
+    const actions = R.filter((a) => a.tags.includes(STEP3), grouped["easyfix"])
+    return actions
+  }
+
+  const easyfixTestingData = processData(getData() || [], "repo_org", "repo_name")
+
+  return (
+    <Row>
+      <Col sm="12">
+        <Easyfix data={easyfixTestingData} key="easyfix" />
+
+        <Button
+          className="actions btn float-left"
+          color="primary"
+          onClick={() => {
+            onPrev("STEP3")
+          }}>
+          <i class="fas fa-chevron-circle-left"></i> Previous
+        </Button>
+      </Col>
+    </Row>
+  )
+}
+
+export default Step4
